package qospolicy

import (
	"context"
	"net/http"
	"strconv"

	"repository.basistech.ru/BASIS/decort-golang-sdk/internal/constants"
	"repository.basistech.ru/BASIS/decort-golang-sdk/internal/validators"
)

type CreateRequest struct {
	// Account ID that owns QoS policy
	// Required: true
	AccountID uint64 `url:"account_id" json:"account_id" validate:"required"`

	// QoS policy name
	// Required: true
	Name string `url:"name" json:"name" validate:"required"`

	// QoS policy description
	// Required: false
	Description string `url:"description,omitempty" json:"description,omitempty"`
}

// Create creates a new QoS policy
func (qp QoSPolicy) Create(ctx context.Context, req CreateRequest) (uint64, error) {
	err := validators.ValidateRequest(req)
	if err != nil {
		return 0, validators.ValidationErrors(validators.GetErrors(err))
	}

	url := "/cloudapi/network_qos_policy/create"

	res, err := qp.client.DecortApiCallCtype(ctx, http.MethodPost, url, constants.MIMEJSON, req)
	if err != nil {
		return 0, err
	}

	result, err := strconv.ParseUint(string(res), 10, 64)
	if err != nil {
		return 0, err
	}

	return result, nil
}
